package es.rickyepoderi.bootablejar.rest;

import es.rickyepoderi.bootablejar.HelloBean;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;

/**
 *
 * @author rmartinc
 */
@Path("/hello")
@RolesAllowed("Users")
//@Stateless
public class HelloEndpoint {

    @GET
    @Produces("application/json")
    @Operation(summary = "Say Hello",
            tags = {"hello"},
            description = "Say hello to the given username and greeting",
            responses = {
                @ApiResponse(description = "The hello bean", content = @Content(schema = @Schema(implementation = HelloBean.class)))
            })
    public HelloBean sayHello(
            @Parameter(description = "The greeting to use") @QueryParam("greeting") String greeting,
            @Parameter(description = "The username to use") @QueryParam("name") String name) {
        return new HelloBean(greeting, name);
    }
}
